//
//  TestViewController.m
//  ShanYanSDK_Demo
//
//  Created by wanglijun on 2019/6/28.
//  Copyright © 2019 wanglijun. All rights reserved.
//

#import "TestViewController.h"
#import "PhoneNumberCheckController.h"
#import <Masonry.h>
#import <SVProgressHUD.h>
#import "ShanYanUIConfigureMaker.h"
#import "ShanYanGetPhoneNumberDemoCode.h"
#import <CLConsole/CLConsole.h>
#import <NSObject+YYModel.h>

@interface TestNavViewController ()
@end
@implementation TestNavViewController

@end

@interface TestViewController ()
@end

@implementation TestViewController

-(BOOL)shouldAutorotate{
    return NO;
}
-(UIInterfaceOrientationMask)supportedInterfaceOrientations{
    return UIInterfaceOrientationMaskPortrait;
}
-(UIInterfaceOrientation)preferredInterfaceOrientationForPresentation{
    return UIInterfaceOrientationPortrait;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    

    // Do any additional setup after loading the view.
    if (@available(iOS 13.0, *)) {
        self.view.backgroundColor = UIColor.systemBackgroundColor;
    } else {
        self.view.backgroundColor = UIColor.whiteColor;
    }
    
    UIImageView * shanYanLogo = [[UIImageView alloc]initWithImage:[UIImage imageNamed:@"icon_flash253"]];
    shanYanLogo.contentMode = UIViewContentModeScaleAspectFit;
    [self.view addSubview:shanYanLogo];
    [shanYanLogo mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.mas_equalTo(0);
        make.width.height.mas_equalTo(self.view).multipliedBy(0.35);
        make.centerY.mas_equalTo(-self.view.bounds.size.height*0.25);
    }];
    
    UIButton * openAuthAPI_CustomVC = [[UIButton alloc]init];
    openAuthAPI_CustomVC.layer.cornerRadius = 22.5;
    openAuthAPI_CustomVC.layer.masksToBounds = YES;
    [openAuthAPI_CustomVC setBackgroundColor:[UIColor colorWithRed:38/255.0 green:94/255.0 blue:250/255.0 alpha:1]];
    [openAuthAPI_CustomVC setTitle:@"拉起授权界面" forState:(UIControlStateNormal)];
    [openAuthAPI_CustomVC addTarget:self action:@selector(openAuthAPIClick:) forControlEvents:(UIControlEventTouchUpInside)];
    [self.view addSubview:openAuthAPI_CustomVC];
    
    UIButton * localPhoneNumberCheckBtn = [[UIButton alloc]init];
    localPhoneNumberCheckBtn.layer.cornerRadius = 22.5;
    localPhoneNumberCheckBtn.layer.masksToBounds = YES;
    [localPhoneNumberCheckBtn setBackgroundColor:[UIColor colorWithRed:38/255.0 green:94/255.0 blue:250/255.0 alpha:1]];
    [localPhoneNumberCheckBtn setTitle:@"闪验本机认证" forState:(UIControlStateNormal)];
    [localPhoneNumberCheckBtn addTarget:self action:@selector(localPhoneNumberCheckBtnClicked) forControlEvents:(UIControlEventTouchUpInside)];
    [self.view addSubview:localPhoneNumberCheckBtn];


    [openAuthAPI_CustomVC mas_makeConstraints:^(MASConstraintMaker *make) {
        make.center.mas_equalTo(0);
        make.width.mas_equalTo(self.view).multipliedBy(0.8);
        make.height.mas_equalTo(45);
    }];
    [localPhoneNumberCheckBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.height.centerX.equalTo(openAuthAPI_CustomVC);
        make.top.equalTo(openAuthAPI_CustomVC.mas_bottom).offset(30);
    }];
}

/// 展示授权页
-(void)openAuthAPIClick:(UIButton *)sender{
    //建议做防止快速点击
    [sender setEnabled:NO];
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(2 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [sender setEnabled:YES];
    });
    [SVProgressHUD show];
    
    CFAbsoluteTime start = CFAbsoluteTimeGetCurrent();

    __weak typeof(self) weakSelf = self;
    
    //    CLUIConfigure * baseUIConfigure = [CLUIConfigure clDefaultUIConfigure];//fast test

    CLUIConfigure * baseUIConfigure;
    NSInteger type_random = arc4random()%3;
    if (type_random == 0) {
        baseUIConfigure = [ShanYanUIConfigureMaker shanYanUIConfigureMakerStyle0];
    }else if (type_random == 1){
        baseUIConfigure = [ShanYanUIConfigureMaker shanYanUIConfigureMakerStyle1];
    }else{
        baseUIConfigure = [ShanYanUIConfigureMaker shanYanUIConfigureMakerStyle2];
    }
//    baseUIConfigure = [ShanYanUIConfigureMaker shanYanUIConfigureMakerStyle0];

    baseUIConfigure.viewController = self;
    
    [CLShanYanSDKManager setCLShanYanSDKManagerDelegate:ShanYanUIConfigureMaker.staticInstancetype];
    
    [CLShanYanSDKManager quickAuthLoginWithConfigure:baseUIConfigure openLoginAuthListener:^(CLCompleteResult * _Nonnull completeResult) {
        CFAbsoluteTime end = CFAbsoluteTimeGetCurrent();

        //建议做防止快速点击
        dispatch_async(dispatch_get_main_queue(), ^{
            [SVProgressHUD dismiss];
            [sender setEnabled:YES];
        });
        
        if (completeResult.error) {
            CLConsoleLog(@"openLoginAuthListener:%@\ncost:%f",completeResult.yy_modelToJSONObject,end - start);
        }else{
            CLConsoleLog(@"openLoginAuthListener:%@\ncost:%f",completeResult.yy_modelToJSONObject,end - start);
        }

    } oneKeyLoginListener:^(CLCompleteResult * _Nonnull completeResult) {
        
        CFAbsoluteTime end = CFAbsoluteTimeGetCurrent();

        __strong typeof(self) strongSelf = weakSelf;
 
        if (completeResult.error) {
            CLConsoleLog(@"oneKeyLoginListener:%@\ncost:%f",completeResult.yy_modelToJSONObject,end - start);
            
            
            //提示：错误无需提示给用户，可以在用户无感知的状态下直接切换登录方式
            if (completeResult.code == 1011){
                //用户取消登录（点返回）
                //处理建议：如无特殊需求可不做处理，仅作为交互状态回调，此时已经回到当前用户自己的页面
                //点击sdk自带的返回，无论是否设置手动销毁，授权页面都会强制关闭
            }  else{
                //处理建议：其他错误代码表示闪验通道无法继续，可以统一走开发者自己的其他登录方式，也可以对不同的错误单独处理
                //1003    一键登录获取token失败
                //其他     其他错误//
                
                //关闭授权页
//                    [CLShanYanSDKManager finishAuthControllerAnimated:YES Completion:nil];
                dispatch_async(dispatch_get_main_queue(), ^{
                    [CLShanYanSDKManager hideLoading];
                });
            }
        }else{
            
            CLConsoleLog(@"oneKeyLoginListener:%@\ncost:%f",completeResult.yy_modelToJSONObject,end - start);

            //测试置换手机号
            [ShanYanGetPhoneNumberDemoCode getPhonenumber:completeResult.data completion:^(NSString * _Nonnull phoneNumber, id  _Nullable responseObject, NSError * _Nonnull error) {
               
                //关闭页面
                [CLShanYanSDKManager finishAuthControllerCompletion:^{
                }];
                
                if (phoneNumber) {
                    CLConsoleLog(@"免密登录成功,手机号：%@",phoneNumber);
                    [SVProgressHUD showSuccessWithStatus:[NSString stringWithFormat:@"免密登录成功,手机号：%@",phoneNumber]];
                    
                }else{
                    
                    if (responseObject) {
                        CLConsoleLog(@"免密登录解密失败:%@",responseObject);
                        [SVProgressHUD showErrorWithStatus:[NSString stringWithFormat:@"免密登录解密失败:%@",responseObject]];
                    }else{
                        CLConsoleLog(@"免密登录解密失败:%@",error.localizedDescription);
                        [SVProgressHUD showErrorWithStatus:[NSString stringWithFormat:@"免密登录解密失败:%@",error.localizedDescription]];
                    }
                }

            }];
        }
    }];
}

//本机号认证
- (void)localPhoneNumberCheckBtnClicked {
    PhoneNumberCheckController * vc = [PhoneNumberCheckController new];
    [self.navigationController pushViewController:vc animated:YES];
}

@end
